<template>
    <div class="wrap">
        <div class="detailContainer">
            <ul>
                <li>
                    <span class="label-wrap">分析文件：</span>
                    <div class="item-content">001.info</div>
                </li>
                <li>
                    <span class="label-wrap">对应录音文件：</span>
                    <div class="item-content">20200606138000001.wav</div>
                </li>
                <li>
                    <span class="label-wrap">坐席姓名：</span>
                    <div class="item-content">张三</div>
                </li>
                <li>
                    <span class="label-wrap">客户号码：</span>
                    <div class="item-content">13800000000</div>
                </li>
                <li>
                    <span class="label-wrap">通话总次数：</span>
                    <div class="item-content">3次 当前为第2次通话录音</div>
                </li>
                <li>
                    <span class="label-wrap">上次沟通时间：</span>
                    <div class="item-content">2020-06-01 17：30</div>
                </li>
            </ul>
        </div>
        <div class="voice-content">
            <div class="client-wrap">
                <span class="person-type">客户：</span>
                <ul>
                    <li v-for="(item,index) in voiceContent.client" :key="index">
                        <Button :type="item.type" size="small" ghost>{{item.content}}</Button>
                    </li>
                </ul>
            </div>
            <div class="agent-wrap">
                <span class="person-type">坐席：</span>
                <ul>
                    <li v-for="(item,index) in voiceContent.agent" :key="index">
                        <Button :type="item.type" size="small" ghost>{{item.content}}</Button>
                    </li>
                </ul>
            </div>
        </div>
        <div class="opera-warp">
            <div class="opera-left">
                <div class="controls-other">
                    <i-switch v-model="switch1" @on-change="change" />
                    <Input search enter-button placeholder="请输入关键字" />
                </div>
                <!-- 播放按钮 -->
                <div class="flex controls-wrap">
                    <Icon type="md-play" @click="play" :size="20"/>
                    <Icon type="md-pause" @click="pause" :size="20"/>
                    <Icon type="md-power" :size="20"/>
                    <!-- 音量 -->
                    <div class="flex volume-wrap">
                        <Icon type="md-volume-up" :size="20"/>
                        <van-slider v-model="volume"></van-slider>
                    </div>
                    <Icon type="md-open" :size="20"/>
                </div>
            </div>
            <div class="select-wrap">
                <span class="label-span">角色选择：</span>
                <Select v-model="role">
                    <Option v-for="item in roles" :value="item.value" :key="item.value">{{ item.label }}</Option>
                </Select>
            </div>
        </div> 
        <!-- 语音波形图 -->
        <div class="waveform-wrap">
            <div id="waveform" ref="waveform"></div>
            <!-- 时间轴 -->
            <div id="wave-timeline" ref="wave-timeline"></div>
        </div>
        <div class="content-wrap">
            <!-- 歌词 -->
            <div class="flex lrc-wrap" @touchstart="pause">
                <van-picker 
                    ref="lrcpicker" 
                    @change="lrcpickerchange" 
                    :columns="columns">
                </van-picker>
            </div>
            <div class="content-right">
                <ul>
                    <li class="li-f">
                        <h3>客户历史沟通画像</h3>
                        <ul>
                            <li v-for="(item,index) in communication" :key="index" class="li-s">
                                <span v-if="item.frequency==1" class="fer-label">首次：</span>
                                <span v-else class="fer-label">第{{item.frequency}}次：</span>
                                <ul>
                                    <li v-for="(ite,inde) in item.figures" :key="inde" class="li-t">
                                        <Button type="primary" size="small">{{ite.label}}</Button>
                                    </li>
                                </ul>
                            </li>
                        </ul>
                    </li>
                    <li class="li-f">
                        <h3>关键信息识别</h3>
                        <ul>
                            <li v-for="(item,index) in keyInfos" :key="index" class="li-s li-s-key">
                                <h4>{{item.keyInfo}}</h4>
                                <div class="info-wrap">
                                    <span>次数：{{item.times}}</span>
                                    <Button type="text">查看位置</Button>
                                </div>
                            </li>
                        </ul>
                    </li>
                    <li class="li-f li-f-content">
                        <h3>通话内容点评</h3>
                        <ul>
                            <li v-for="(item,index) in reviews" :key="index" class="li-s">
                                <Button size="small">{{item.label}}</Button>
                            </li>
                            <li class="li-s">
                                <Button size="small" >+新增</Button>
                            </li>
                        </ul>
                        <Input v-model="opinion" type="textarea" :rows="4" placeholder="填写问题详情及改进意见" />
                    </li>
                </ul>
            </div>
        </div>    
    </div>
</template>

<script>
    import WaveSurfer from 'wavesurfer.js'
    import Timeline from 'wavesurfer.js/dist/plugin/wavesurfer.timeline.js'
    let playTimeoutTag = 0;
    import { Picker,Icon,Slider} from 'vant';
    import lrc from './data';
    export default {
        name: "Detail",
        data() {
            return {
                volume: 100,
                progress: 0,
                progressCurrent: 0,
                progressLength: 0,
                columns: [],
                columnsTime:[
                    '0.40',
                    '3.28',
                    '0.93',
                    '3.48',
                    '0.37',
                    '8.83',
                    '1.22',
                    '0.37',
                    '2.91',
                    '11.03',
                    '3.75',
                    '3.29',
                    '2.29',
                    '2.00',
                    '0.20',
                    '31.81',
                    '4.98',
                    '5.64',
                    '12.22',
                    '43.46',
                    '0.59',
                    '7.43',
                    '0.45',
                    '0.29',
                    '2.75',
                    '13.51',
                    '0.46',
                    '27.09',
                    '0.46',
                    '19.02',
                    '1.24',
                    '1.11',
                    '3.66',
                    '26.28',
                    '0.80',
                    '2.01',
                    '0.54',
                    '16.84',
                    '3.38',
                    '2.29',
                    '6.64',
                    '4.41',
                    '2.79',
                    '7.66',
                    '3.67',
                    '11.59',
                    '1.40',
                    '0.79',
                    '1.59',
                    '5.68',
                    '2.49',
                    '9.42',
                    '10.70',
                    '7.30',
                    '1.41',
                    '0.94',
                    '4.47',
                    '1.20',
                    '0.61',
                    '3.95',
                    '3.03',
                    '2.42',
                    '7.51',
                    '14.07',
                    '1.82',
                    '1.04',
                    '4.75',
                    '2.47',
                    '4.89',
                    '4.23',
                    '10.64',
                    '2.96',
                    '5.14',
                    '0.66',
                    '2.33',
                    '0.79',
                    '2.20',
                    '2.87',
                    '3.87',
                    '7.27',
                    '7.07',
                    '7.67',
                    '13.03',
                    '4.91',
                    '10.09',
                    '3.39',
                    '10.60',
                    '7.82',
                    '6.02',
                    '2.16',
                    '3.42',
                    '5.97',
                    '2.76',
                    '0.73',
                    '0.29',
                    '3.87',
                    '3.66',
                    '5.91',
                    '2.85',
                    '0.26',
                ],
                wavesurfer: null,
                audio:null,
                switch1: false,
                role:null,
                roles:[
                    {
                        value:'agent',
                        label:'坐席'
                    },
                    {
                        value:'client',
                        label:'客户'
                    },
                    {
                        value:'all',
                        label:'全部'
                    }
                ],
                communication:[
                    {
                        frequency:1,
                        figures:[
                            {
                                label:'不方便电话'
                            }
                        ]
                    },
                    {
                        frequency:2,
                        figures:[
                            {
                                label:'嫌贵'
                            },
                            {
                                label:'犹豫不决'
                            },
                            {
                                label:'犹豫不决'
                            },
                            {
                                label:'犹豫不决'
                            },
                            {
                                label:'犹豫不决'
                            }
                        ]
                    },
                    {
                        frequency:3,
                        figures:[
                            {
                                label:'不方便电话'
                            }
                        ]
                    },
                ],
                keyInfos:[
                    {
                        keyInfo:'非车推荐',
                        times:2
                    },
                    {
                        keyInfo:'非车推荐',
                        times:2
                    }
                ],
                reviews:[
                    {
                        label:'缺乏技巧'
                    },
                    {
                        label:'缺乏技巧'
                    }
                ],
                opinion:null,
                voiceContent:{
                    client:[
                        {
                            content:'开场白',
                            type:'info',
                        },
                        {
                            content:'报价',
                            type:'warning',
                        },
                        {
                            content:'异议处理-未到期',
                            type:'error',
                        },
                        {
                            content:'促成',
                            type:'success',
                        }
                    ],
                    agent:[
                        {
                            content:'开场白',
                            type:'info',
                        },
                        {
                            content:'报价',
                            type:'warning',
                        },
                        {
                            content:'异议处理-未到期',
                            type:'error',
                        },
                        {
                            content:'促成',
                            type:'success',
                        }
                    ]
                },
                warns:[
                    '哈哈',
                ],
                keyword:[
                    '平台'
                ]
            }
        },
        components:{
            [Picker.name]: Picker,
            [Icon.name]: Icon,
            [Slider.name]: Slider,
        },
        computed: {
            progressCurrentText() {
                return `${String(this.progressCurrent/60>>0).padStart(2,'0')}:${String(this.progressCurrent%60>>0).padStart(2,'0')}`
            },
            progressLengthText() {
                return `${String(this.progressLength/60>>0).padStart(2,'0')}:${String(this.progressLength%60>>0).padStart(2,'0')}`
            },
        },
        watch: {
            volume() {
                this.$refs.audio.volume = this.volume / 100
            }
        },
        mounted() {
            this.$nextTick(() => {
                this.wavesurfer = WaveSurfer.create({
                    container: this.$refs.waveform,
                    waveColor: '#409EFF',
                    progressColor: 'blue',
                    backend: 'MediaElement',
                    mediaControls: false,
                    audioRate: '1',
                    //使用时间轴插件
                    plugins: [
                        Timeline.create({
                        container: '#wave-timeline'
                        }),
                    ]
                });
                // this.wavesurfer.load(require('../assets/隔壁老樊 - 多想在平庸的生活拥抱你.flac'));
                this.wavesurfer.load(require('../assets/SIP-10193_50243456_20191204201732.wav'));
                this.columns =lrc;
                setTimeout(() => {
                    this.audio=document.querySelector('#waveform audio');
                    this.audio.addEventListener("timeupdate",this.timeupdate,false);
                    this.audio.addEventListener("loadedmetadata",this.loadedmetadata,false);
                    let lrcLi=document.getElementsByClassName('van-picker-column__item');
                    this.columns.forEach((item,index)=>{
                        let divColor=lrcLi.item(index).querySelector('.van-ellipsis');
                        if(item.indexOf('n0')!==-1){
                            this.warns.forEach((ite)=>{
                                if(item.indexOf(ite)!==-1){
                                    divColor.style.color='#f90';
                                }
                            });
                            this.keyword.forEach((ites)=>{
                                if(item.indexOf(ites)!==-1){
                                    divColor.style.color='#ed4014';
                                }
                            });
                            lrcLi.item(index).style.cssText="justify-content: center;flex-direction: column;align-items: flex-end;flex-wrap: wrap;"
                            let divNode=document.createElement('div');
                                divNode.style.cssText="display: flex;align-items: center;color:#fff;font-size: 14px;"
                            let imgNode = document.createElement('img');
                                imgNode.src=require('../assets/server.png');
                            let spanNode = document.createElement('span');
                                spanNode.style.cssText="margin:0 10px;padding:0 7px;color: #808695;border:1px solid #808695;background: 0 0;"
                                spanNode.innerText=`${this.columnsTime[index]}`;
                            let buttonNode = document.createElement('button');
                                buttonNode.type="text";
                                buttonNode.innerText=`开场白`;
                                buttonNode.style.cssText="padding:0 7px;color: #2db7f5;border:1px solid #2db7f5;background: 0 0;";
                                divNode.appendChild(imgNode);
                                divNode.appendChild(spanNode);
                                divNode.appendChild(buttonNode);
                                lrcLi.item(index).insertBefore(divNode,lrcLi.item(index).childNodes[0]);    
                                divColor.innerText=item.substring(item.indexOf("：")+1);
                        }else{
                            lrcLi.item(index).style.cssText="justify-content: center;flex-direction: column;align-items: flex-start;flex-wrap: wrap;"
                            let divNode=document.createElement('div');
                                divNode.style.cssText="display: flex;align-items:center;color:#fff;font-size: 14px;"
                            let imgNode = document.createElement('img');
                                imgNode.src=require('../assets/user.png');
                            let spanNode = document.createElement('span');
                                spanNode.style.cssText="margin:0 10px;padding:0 7px;color: #808695;border:1px solid #808695;background: 0 0;"
                                spanNode.innerText=`${this.columnsTime[index]}`;
                                divNode.appendChild(imgNode);
                                divNode.appendChild(spanNode);
                                lrcLi.item(index).insertBefore(divNode,lrcLi.item(index).childNodes[0]);
                                divColor.innerText=item.substring(item.indexOf("：")+1);
                        }
                    })
                }, 200);
            })
        },
        methods: {
            change (status) {
                console.log(status);
            },
            play() {
                clearTimeout(playTimeoutTag)
                playTimeoutTag = setTimeout(() => {
                    this.wavesurfer.play()
                }, 200);
            },
            pause() {
                clearTimeout(playTimeoutTag)
                this.wavesurfer.pause()
            },
            progressChange(val) {
                console.log('progressChange', arguments);
                this.pause()
                this.audio.currentTime = val;
                this.play();
            },
            loadedmetadata() {
                this.progressCurrent = this.audio.currentTime;
                this.progressLength = this.audio.duration;
                this.volume = this.audio.volume * 100
            },
            lrcpickerchange(el, value) {
                var time = value && value.match(/(\d+):(\d+)\.(\d+)/);
                if (time && time.length) {
                    this.audio.currentTime = time[1] * 60 + (+time[2]);
                    this.play()
                }
            },
            timeupdate() {
                this.progressCurrent = this.audio.currentTime;
                var findItem = this.columns.findIndex(v => {
                    var result = v.match(/(\d+):(\d+)\.(\d+)/);
                    if (result && result.length) {
                        var value = result[1] * 60 + (+result[2]);
                        return value > this.audio.currentTime
                    }
                    return false
                }) || -1
                this.$refs.lrcpicker.setValues([this.columns[Math.min(Math.max(0, findItem - 1), this
                    .columns.length - 1)]])
            }
        }
    }
</script>

<style scoped lang="scss">
    .wrap {
        padding: 10px;
        background: #f5f7f9;
        .waveform-wrap{
            background-color: #fff;
            border: 1px solid #e3e7f1;
            border-top: none;
            padding: 0 10px;
            margin-bottom: 20px;
            .lrc-column{
                justify-content: center;
                flex-direction: column;
                align-items: flex-end;
            }
        }
        .voice-content{
            background-color: #fff;
            border: 1px solid #e3e7f1;
            border-bottom: none;
            padding: 10px 10px;
            div{
                display: flex;
                .person-type{
                    flex: 0 0 70px;
                }
            }
            .client-wrap{
                margin-bottom: 15px;
            }
            ul{
                display: flex;
                justify-content: space-around;
                flex-grow: 1;
                flex-shrink: 0;
                li{
                    color: #fff;
                    padding: 0 10px;
                }
            }
        }
        .opera-warp{
            display: flex;
            justify-content: space-between;
            align-items: center;
            height: 45px;
            background-color: #fff;
            border-left: 1px solid #e3e7f1;
            border-right: 1px solid #e3e7f1;
            padding: 0 10px;
            .opera-left{
                display: flex;
                align-items: center;
                flex-grow: 1;
                justify-content: space-between;
                .controls-other{
                    display: flex;
                    align-items: center;
                    margin-left: 45px;
                    .ivu-switch{
                        margin-right: 30px;
                    }
                }
                .volume-wrap{
                    width: 100px;
                    margin-right: 20px;
                }
                .controls-wrap {
                    margin-right: 45px;
                    i{
                        margin-right: 10px;
                    }
                }
            }
            .select-wrap{
                width: 25%;
                display: flex;
                align-items: center;
                .label-span{
                    flex-grow: 1;
                    text-align: right;
                }
                .ivu-select{
                    width: 200px;
                }
            }
        }
        .content-wrap{
            display: flex;
            .lrc-wrap {
                flex-grow: 1;
                border: 1px solid #e3e7f1;
                height: 600px;
                /deep/.van-picker{
                    width: 100%;
                    height: 100%;
                    .van-picker__columns{
                        height: 100% !important;
                        .van-picker-column{
                            overflow: scroll;
                            .van-picker-column__wrapper{
                                padding: 20px;
                                .van-picker-column__item--selected{
                                    color: #2d8cf0;
                                }
                            }
                            .van-ellipsis{
                                white-space:pre-wrap;
                                max-width: 50%;
                            }
                        }
                    }
                }
            }
            .content-right{
                width: 25%;
                padding: 0 10px;
                ul{
                    .li-f{
                        margin-bottom: 20px;
                        h3{
                            margin-bottom: 10px;
                        }
                    }
                    .li-f-content{
                        ul{
                            display: flex;
                            li{
                                padding: 5px;
                            }
                        }
                    }
                    .li-s{
                        display: flex;
                        padding: 5px 0;
                        .fer-label{
                            line-height: 42px;
                            flex: 0 0 70px;
                            text-align: right;
                        }
                        ul{
                            display: flex;
                            flex-wrap: wrap;
                            align-items: center;
                            .li-t{
                                display: flex;
                                padding: 5px;
                            }
                        }
                    }
                    .li-s-key{
                        flex-direction: column;
                        .info-wrap{
                            .ivu-btn-text{
                                color: #57a3f3;
                            }
                        }
                    }
                }
            }
        }
    }
    .flex {
        display: flex;
        align-items: center;
    }
    .progress-time {
        width: 8em;
        text-align: center;
    }
    
</style>
